"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class VariantMetadata(ProtocolElement):
    """
    No documentation
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {}

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_2 import opencb as opencb_2_9_3
        from protocols.protocol_8_2 import opencb as opencb_2_9_3

        return {
            "species": opencb_2_9_3.Species,
            "studies": opencb_2_9_3.VariantStudyMetadata,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_2 import opencb as opencb_2_9_3
        from protocols.protocol_8_2 import opencb as opencb_2_9_3

        return {
            "org.opencb.biodata.models.metadata.Species": opencb_2_9_3.Species,
            "org.opencb.biodata.models.variant.metadata.VariantStudyMetadata": opencb_2_9_3.VariantStudyMetadata,
            "org.opencb.biodata.models.variant.metadata.VariantMetadata": opencb_2_9_3.VariantMetadata,
        }

    __slots__ = [
        "creationDate",
        "description",
        "species",
        "studies",
        "version",
    ]

    def __init__(
        self,
        creationDate=None,
        description=None,
        species=None,
        studies=list,
        version="v1.0.0",
        validate=None,
        **kwargs
    ):
        """Initialise the opencb_2_9_3.VariantMetadata model.

        :param creationDate:
            Creation date
        :type creationDate: None | str
        :param description:
            Optional description
        :type description: None | str
        :param species:
            Species information. Same species and assembly for all the studies
        :type species: None | Species
        :param studies:
            List of studies within this set of data
        :type studies: list[VariantStudyMetadata]
        :param version:
            Data model version
        :type version: str
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "2.9.3-GEL"
